unit hiHost;

interface

uses Kol,Share,Debug,Win,{Windows,}winsock,err,ShellApi;

type
  THIHost = class(TDebug)
   private
   
   public
    

    ip,Host:string;
    _event_onLoacalHostName : THI_Event;
    _event_onHost_IP : THI_Event;
    _event_onIP_Host : THI_Event;
    _data_IPAdd : THI_Event;
    _data_HostName : THI_Event;
    
    procedure _work_doLoad(var _Data:TData; Index:word);
    function uGetLoacalHostName:string ; 
    function uHost2IP(HostName:string): String; 
    function uIP2Host(IPAddr : String): String; 
  end;

implementation

procedure THIHost._work_doLoad;
var s:string;
begin
  
  s := uGetLoacalHostName;
  _hi_OnEvent(_event_onLoacalHostName,s);
  Host := ReadString(_Data,_data_HostName,s);
  _hi_OnEvent(_event_onHost_IP,uHost2IP(Host));
   ip := ReadString(_Data,_data_IPAdd,'');
  _hi_OnEvent(_event_onIP_Host,uIP2Host(uHost2IP(ip)));
  
end;
//////////////////////////////////////////////////////////////////////////////////////////////////
function THIHost.uGetLoacalHostName:string ;
var
 Buffer: Array[0..63] of Char;
 GInitData: TWSAData;

begin
 WSAStartup($101, GInitData);
 Result := '';
 winsock.GetHostName(Buffer, SizeOf(Buffer));
 Result := Buffer;
 WSACleanup;
end;
////////////////////////////////////////////////////////////////////////////////
function THIHost.uHost2IP(HostName:string): String;
type
 TaPInAddr = Array[0..10] of PInAddr;
 PaPInAddr = ^TaPInAddr;
var
 phe: PHostEnt;
 pptr: PaPInAddr;
 I: Integer;
 GInitData: TWSAData;
begin
 Result := '';
 WSAStartup($101, GInitData);
 phe := GetHostByName(@HostName[1]);
 if phe = nil then Exit;
 pPtr := PaPInAddr(phe^.h_addr_list);
 I := 0;
 while pPtr^[I] <> nil
 do
  begin
   Result := inet_ntoa(pPtr^[I]^);
   Inc(I);
  end;
 WSACleanup;
end;
////////////////////////////////////////////////////////////////////////////////
function THIHost.uIP2Host(IPAddr : String): String;
var
  SockAddrIn: TSockAddrIn;
  HostEnt: PHostEnt;
  WSAData: TWSAData;
begin
  WSAStartup($101, WSAData);
  SockAddrIn.sin_addr.s_addr:= inet_addr(PChar(IPAddr));
  HostEnt:= gethostbyaddr(@SockAddrIn.sin_addr.S_addr, 4, AF_INET);
  if HostEnt<>nil then
  begin
    result:=Hostent^.h_name;
  end
  else
  begin
    result:='';
  end;
end;
////////////////////////////////////////////////////////////////////////////////

end.
